summaryrefslogtreecommitdiffstats
path: root/config/utils/check-jinja2.sh
diff options
context:
space:
mode:
Diffstat (limited to 'config/utils/check-jinja2.sh')
-rwxr-xr-xconfig/utils/check-jinja2.sh30
1 files changed, 25 insertions, 5 deletions
diff --git a/config/utils/check-jinja2.sh b/config/utils/check-jinja2.sh
index 3c5e5163..1fcdb9a2 100755
--- a/config/utils/check-jinja2.sh
+++ b/config/utils/check-jinja2.sh
@@ -1,7 +1,7 @@
#!/bin/bash
# SPDX-license-identifier: Apache-2.0
##############################################################################
-# Copyright (c) 2016 Linux Foundation and others.
+# Copyright (c) 2018 Linux Foundation and others.
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Apache License, Version 2.0
# which accompanies this distribution, and is available at
@@ -12,8 +12,15 @@ set +x
set +o errexit
export PATH=$PATH:/usr/local/bin/
-GEN_CFG='./config/utils/generate_config.py'
-INSTALLER_ADAPTERS='./config/installers/*'
+# Optional filtering of test matrix: per-lab, per-pod, per-installer
+# e.g. To check zte-pod{2,3} against all installer adapters:
+# ./config/utils/check-jinja2.sh zte 'pod(2|3)'
+FILTER_LAB=${1:-*} # e.g. 'zte' (glob)
+FILTER_POD=${2:-(pod|virtual)[[:digit:]]+} # e.g. 'pod1' (regex)
+FILTER_IA=${3:-*} # e.g. 'fuel' (glob)
+
+GEN_CFG='python ./config/utils/generate_config.py'
+INSTALLER_ADAPTERS="./config/installers/${FILTER_IA}"
TMPF='/tmp/out.yml' # should be outside Jenkins WS to prevent data leakage
RC=0
@@ -25,15 +32,27 @@ for adapter in 'PDF Verify Matrix' ${INSTALLER_ADAPTERS}; do
done
# Iterate all PDFs, check with each installer adapter, log results
+# shellcheck disable=SC2086
while IFS= read -r lab_config; do
SUMMARY+="\n${lab_config#labs/};"
+ idf_config="$(dirname "${lab_config}")/idf-$(basename "${lab_config}")"
+ idf_installer=$(grep 'installer:' "${idf_config}" 2>/dev/null || echo)
echo "###################### ${lab_config} ######################"
for adapter in ${INSTALLER_ADAPTERS}; do
pdf_inst=0
pdf_inst_pass=0
pdf_yaml_pass=0
+ installer_name=$(basename "${adapter}")
+ if [ -n "${idf_installer}" ] && echo "${idf_installer}" | \
+ grep -vq "${installer_name}"; then
+ SUMMARY+='-;'
+ echo -n "[GENERATE] [SKIP] idf.installer defined and "
+ echo -e "${installer_name} not listed, skipping.\n"
+ continue
+ fi
while IFS= read -r jinja_template; do
- pdf_gen_cmd="${GEN_CFG} -y ${lab_config} -j ${jinja_template}"
+ pdf_gen_cmd="${GEN_CFG} -y ${lab_config} -j ${jinja_template} \
+ -i $(dirname "${jinja_template}")"
if ${pdf_gen_cmd} > "${TMPF}"; then
((pdf_inst_pass+=1))
echo "[GENERATE] [OK] ${pdf_gen_cmd}"
@@ -52,7 +71,8 @@ while IFS= read -r lab_config; do
done < <(find "${adapter}" -name '*.j2')
SUMMARY+="${pdf_yaml_pass}/${pdf_inst_pass}/${pdf_inst};"
done
-done < <(find 'labs' -name 'pod*.yaml')
+done < <(find labs/${FILTER_LAB} -regextype egrep \
+ -regex "labs/.+/${FILTER_POD}.yaml")
rm -f "${TMPF}"
cat <<EOF